
rbd - Feature #1480

librbd: image locking

08/31/2011 06:19 PM - Sage Weil

Status: Resolved % Done: 0%

Priority: Normal Spent time: 0.00 hour

Assignee: Greg Farnum   

Category:    

Target version: v0.49   

Source:  Reviewed:  

Tags:  Affected Versions:  

Backport:  Pull request ID:  

Description

Implement cooperative locking of RBD images (coordinated on the header, of course). Write public class functions to support both

exclusive and shared locking, to list lock holders, and to let third parties remove locks. Then implement corresponding librbd

functions, and write tests for the new functionality.

Support having multiple locks from the same entity (ie, multiple VMs on the same KVM host) by storing lockers as both the entity and

a request-defined cookie.

History

#1 - 08/31/2011 09:53 PM - Sage Weil

- Target version set to v0.38

#2 - 08/31/2011 10:24 PM - Sage Weil

- Target version deleted (v0.38)

- translation missing: en.field_position set to 43

#3 - 09/02/2011 03:45 PM - Sage Weil

- translation missing: en.field_position deleted (54)

- translation missing: en.field_position set to 36

#4 - 06/05/2012 09:45 AM - Sage Weil

- translation missing: en.field_position deleted (364)

- translation missing: en.field_position set to 20

#5 - 06/05/2012 09:45 AM - Sage Weil

- Subject changed from rbd: EBUSY locking to rbd: image locking

- translation missing: en.field_position deleted (20)

- translation missing: en.field_position set to 20

#6 - 06/05/2012 09:56 AM - Sage Weil

lock(entity)

unlock(entity)

new code should lock before open, unlock on close.

the rbd map tool have 'lock list', 'lock add', 'lock break' commands (maybe better verbs tho?).

a paranoid user can blacklist a node they are breaking the lock for before breaking it, to ensure they don't corrupt the image.
#7 - 06/06/2012 08:22 PM - Sage Weil

- translation missing: en.field_position deleted (21)

- translation missing: en.field_position set to 9

#8 - 06/08/2012 09:49 AM - Greg Farnum

- Assignee set to Greg Farnum

#9 - 06/12/2012 01:49 PM - Greg Farnum

- Description updated

#10 - 06/12/2012 01:55 PM - Greg Farnum

- Description updated

#11 - 06/13/2012 02:26 PM - Sage Weil

- Target version set to v0.49

- translation missing: en.field_position deleted (29)

- translation missing: en.field_position set to 1313

#12 - 06/13/2012 02:27 PM - Sage Weil

- translation missing: en.field_story_points set to 5

- translation missing: en.field_position deleted (1313)

- translation missing: en.field_position set to 1313

#13 - 06/13/2012 03:19 PM - Sage Weil

- Target version deleted (v0.49)

- translation missing: en.field_position deleted (1314)

- translation missing: en.field_position set to 2

#14 - 06/13/2012 03:19 PM - Sage Weil

- Target version set to v0.49

- translation missing: en.field_position deleted (3)

- translation missing: en.field_position set to 1316

#15 - 06/13/2012 03:19 PM - Sage Weil

- Subject changed from rbd: image locking to librbd: image locking

- translation missing: en.field_position deleted (1316)

- translation missing: en.field_position set to 1316

#16 - 06/14/2012 02:37 PM - Greg Farnum

- Status changed from New to Fix Under Review

wip-rbd-locking

#17 - 06/15/2012 05:49 PM - Greg Farnum

And after thorough review from Josh, this should be ready for merge (commit:5b1b02b60a253092700f364dca77bb6b1065e3e0). But I'm holding off

because I don't know if we want to set up a plan for rbd merges this sprint.

#18 - 06/15/2012 05:58 PM - Greg Farnum

- Status changed from Fix Under Review to Resolved
Okay, discussed and merged in commit:dac9f223598c5f67b228403e514f202280d56488

#19 - 06/29/2012 09:48 AM - Sage Weil

- Project changed from Ceph to rbd

- Category deleted (librbd)

#20 - 06/29/2012 09:52 AM - Sage Weil

- Target version deleted (v0.49)

#21 - 06/29/2012 09:54 AM - Sage Weil

- Target version set to v0.49
